<script setup>
// ----------------------------------------------------------------
// Imports
// ----------------------------------------------------------------

// To see the list of imports, copy the final content of option (after setup) into the site:
// https://vue-echarts.dev/#codegen
import { BarChart } from "echarts/charts";
import {
  GridComponent,
  LegendComponent,
  ToolboxComponent,
  TooltipComponent,
} from "echarts/components";
import { use } from "echarts/core";
import { CanvasRenderer } from "echarts/renderers";
import { provide, ref } from "vue";
import VChart, { THEME_KEY } from "vue-echarts";

// ----------------------------------------------------------------
// Probs
// ----------------------------------------------------------------

const props = defineProps({
  data: {
    type: Object,
    required: true,
  },
  totalSize: {
    type: Number,
    required: true,
  },
});

use([
  TooltipComponent,
  ToolboxComponent,
  LegendComponent,
  GridComponent,
  BarChart,
  CanvasRenderer,
]);

// ----------------------------------------------------------------
// Variables
// ----------------------------------------------------------------

const loading = ref(true);
const option = ref({
  tooltip: {
    trigger: "axis",
    axisPointer: {
      type: "shadow",
    },
    valueFormatter: value =>
      `${formatBytes(value)} (${((value * 100) / props.totalSize).toFixed(2)}%)`,
  },
  toolbox: {
    show: true,
    feature: {
      saveAsImage: {},
    },
  },
  legend: {},
  grid: {
    left: "0%",
    right: "0%",
    bottom: "0%",
    containLabel: true,
  },
  xAxis: {
    type: "value",
    splitLine: { show: false },
    axisLine: { show: false },
    axisTick: { show: false },
    axisLabel: { show: false },
    min: 0,
  },
  yAxis: {
    type: "category",
    data: ["Repartition"],
    splitLine: { show: false },
    axisLine: { show: false },
    axisTick: { show: false },
    axisLabel: { show: false },
  },
  series: [],
});

// ----------------------------------------------------------------
// Functions
// ----------------------------------------------------------------

function generateOption() {
  const seriesTemp = [];
  for (const key in props.data) {
    seriesTemp.push({
      name: key,
      type: "bar",
      stack: "total",
      label: {
        show: true,
        formatter: function (d) {
          return formatBytes(d.data);
        },
      },
      emphasis: {
        focus: "series",
      },
      data: [props.data[key].TotalSize],
    });
  }

  option.value.xAxis.max = props.totalSize;
  option.value.series = seriesTemp;
  loading.value = false;
}

// ----------------------------------------------------------------
// Watch
// ----------------------------------------------------------------

watch(
  () => props.data,
  async () => {
    if (props.data !== null) {
      generateOption();
    }
  },
);

// ----------------------------------------------------------------
// Main
// ----------------------------------------------------------------

generateOption();
provide(THEME_KEY, "light");
</script>

<template>
  <div class="ma-3">
    <VChart
      class="chart"
      :option="option"
      :loading="loading"
    />
  </div>
</template>

<style scoped>
.chart {
  height: 100px;
  width: 100%;
}
</style>
